<?php
/**
 * @package Admin
 * @todo    Settings page for WHMpress admin panel
 */

if ( ! defined( 'WHMP_VERSION' ) ) {
	header( 'Status: 403 Forbidden' );
	header( 'HTTP/1.1 403 Forbidden' );
	exit();
}

global $wpdb; ?>
<div class="wrap">
<div class="whmp-main-title"><span class="whmp-title">WHMpress</span> Settings</div>

<div class="updated">
<p><strong>General</strong>: Select if you wish to use http or https (SSL) url for placing orders.<br />
<strong>Styles</strong>: WHMpress comes with a set of predefined styles, selected style CSS will be used if you use "whmcs-defualt" as CSS class. If CSS is not provided or is empty your current themes CSS will be used to show basic componenets.<br />
<strong>Short Code Defaults</strong>: Default settings for Shortcodes, all these settings can be overridden in Shortcodes.<br />
<strong>Ajax Domain Search</strong>: Setting for AJax Domain Search Extension. </p>
</div>

<?php if (isset($_GET["settings-updated"]) && $_GET["settings-updated"]=="true") echo "<div class='updated'><p><b>Success</b><br />Settings saved.</p></div>"; ?>

<form method="post" action="options.php"> 
<?php settings_fields( 'whmp_settings' );
do_settings_sections( 'whmp_settings' ); ?>

<ul class='tabs'>
    <li><a href='#general'>General</a></li>
    <li><a href="#styles">Styles</a></li>
    <?php if (function_exists('whmpress_domain_search_ajax_function')): ?>
    <li><a href="#ajax_domain_search">Ajax Domain Search</a></li>
    <?php endif; ?>
    <li><a href="#defaults">Short Code Defaults</a></li>
</ul>

<div id="general">
<table class="form-table">
    <tr valign="top">
        <td scope="row" style="width:30%;">WHMCS URL</td>
        <td>
        <?php $Q = "SELECT `value` FROM `".whmp_get_configuration_table_name()."` WHERE `setting`='SystemURL' OR `setting`='SystemSSLURL' ORDER BY `setting` DESC";
        $Us = $wpdb->get_results($Q,ARRAY_A); ?>
        <select style="width:100%;" name="whmcs_url">
            <?php foreach($Us as $U): $S = get_option("whmcs_url")==$U["value"]?"selected=selected":"" ?>
            <option <?php echo $S ?>><?php echo $U["value"] ?></option>
            <?php endforeach; ?>
        </select>
        </td>
    </tr>
    <tr valign="top">
        <td scope="row" style="width:30%;">Decimal Seperator</td>
        <td>
        <input style="width:100%;" name="decimal_replacement" value="<?php echo esc_attr( get_option('decimal_replacement',".") ); ?>">
        </td>
    </tr>
    <tr valign="top">
        <td scope="row" style="width:30%;">Show symbol with price</td>
        <td>
        <?php $symb = esc_attr( get_option('default_currency_symbol',"prefix") ); ?>
        <select style="width:100%;" name="default_currency_symbol">
            <option value="prefix">Prefix</option>
            <option value="suffix" <?php echo $symb=="suffix"?"selected=selected":""; ?>>Suffix</option>
            <option value="code" <?php echo $symb=="code"?"selected=selected":""; ?>>Code</option>
            <option value="none" <?php echo $symb=="none"?"selected=selected":""; ?>>None</option>
        </select>
        </td>
    </tr>
    <!--tr valign="top">
        <td scope="row">URL for domain search form</td>
        <td><input style="width:100%;" name="domain_search_url" value="<?php echo esc_attr( get_option('domain_search_url') ); ?>" /></td>
    </tr>
    
    <tr valign="top">
        <td scope="row">Whois DB</td>
        <td><textarea style="width:100%;" rows="15" name="whois_db"><?php echo esc_attr( get_option('whois_db') ); ?></textarea></td>
    </tr-->
    <tr>
        <td>&nbsp;</td>
        <td><?php submit_button(); ?></td>
    </tr>
</table>
</div>

<div id="styles">
    <table class="form-table">
        <tr scope="row">
            <td style="width:30%;">Select style</td>
            <td>
                <select name="whmp_custom_css">
                    <?php $theme_files = glob(WHMP_PLUGIN_DIR."/styles/*.css");
                    if (is_array($theme_files)) foreach($theme_files as $theme_file): ?>
                    <option><?php echo basename($theme_file) ?></option>
                    <?php endforeach; ?>
                </select>
            </td>
        </tr>
        <tr scope="row">
            <td valign="top" style="width:30%;">Include font awesome</td>
            <td>
                <select name="include_fontawesome">
                    <option value="0">No</option>
                    <option value="1" <?php echo get_option('include_fontawesome')=="1"?"selected=selected":"" ?>>Yes</option>
                </select><br />
                <span style="color: #CC0000;">
                <b>Note:</b> <a href="http://fontawesome.io/icons/" target="_blank">FontAwesome</a> is font icons library, which is used by our "Pricing Table Groups". If your theme doesn't include FontAwesome then you can use FontAwesome.
                </span>
            </td>
        </tr>
        <tr>
            <td></td>
            <td><?php submit_button(); ?></td>
        </tr>
    </table>
</div>

<?php if (function_exists('whmpress_domain_search_ajax_function')): ?>
<div id="ajax_domain_search">
    <h3 class="whmp-sub-head">Custom Messages</h3>
    <table class="form-table">
        <tr valign="top">
            <td style="width:30%;" scope="row">Domain available message</td>
            <td><input style="width:100%;" name="domain_available_message" value="<?php echo esc_attr( get_option('domain_available_message') ); ?>" /></td>
        </tr>
        <tr valign="top">
            <td scope="row">Domain not available message</td>
            <td><input style="width:100%;" name="domain_not_available_message" value="<?php echo esc_attr( get_option('domain_not_available_message') ); ?>" /></td>
        </tr>
        <tr valign="top">
            <td scope="row">Ongoing domain not available message</td>
            <td><input style="width:100%;" name="ongoing_domain_not_available_message" value="<?php echo esc_attr( get_option('ongoing_domain_not_available_message',"[domain-name] is registered") ); ?>" /></td>
        </tr>
        <tr valign="top">
            <td scope="row">Recommended domains list message</td>
            <td><input style="width:100%;" name="domain_recommended_list" value="<?php echo esc_attr( get_option('domain_recommended_list') ); ?>" /></td>
        </tr>
    </table>
    <h3 class="whmp-sub-head">Domain Search Options</h3>
    <table class="form-table">
        <tr valign="top">
            <td style="width:30%;" scope="row">Number of domains to show in load more page</td>
            <td><input type="number" style="width:100%;" name="no_of_domains_to_show" value="<?php echo esc_attr( get_option('no_of_domains_to_show','10') ); ?>" /></td>
        </tr>
        <tr valign="top">
            <td scope="row">TLD orders, (Comma seprated)</td>
            <td><textarea style="width:100%;" rows="5" name="tld_order"><?php echo esc_attr( get_option('tld_order') ); ?></textarea></td>
        </tr>
    </table>
    <h3 class="whmp-sub-head">Who is Servers</h3>
    <table class="form-table">
        <tr>
            <td style="width:30%;" scope="row">Whois Servers</td>
            <td>
                <textarea style="width:100%;" rows="15" name="whois_db"><?php echo whmpress_get_option('whois_db'); ?></textarea>
            </td>
        </tr>
        <tr>
            <td></td>
            <td><?php submit_button(); ?></td>
        </tr>
    </table>
</div>
<?php endif; ?>

<style>
#price table tr th {
    text-align:right;
}
</style>
<div id="defaults">
    <h3 class="whmp-sub-head">Price Defaults <small>[whmpress_price]</small></h3>
    <table class="form-table">
        <tr valign="top">
            <td style="width:30%;" scope="row">Billing cycle</td>
            <td colspan="2">
                <?php
                $selected = whmpress_get_option('billingcycle');
                $data = array("monthly"=>"Monthly",
                    "annually"=>"Annually",
                    "quarterly"=>"Quarterly",
                    "semiannually"=>"Semi Annually",
                    "biennially"=>"Biennially",
                    "triennially"=>"Triennially");
                echo whmpress_draw_combo($data,$selected,"billingcycle");
                ?>
            </td>
        </tr>
        <tr valign="top">
            <td scope="row">Hide decimals</td>
            <td colspan="2">
                <?php
                $selected = whmpress_get_option('hide_decimal');
                $data = array("No","Yes");
                echo whmpress_draw_combo($data,$selected,"hide_decimal");
                ?>
            </td>
        </tr>
        <tr valign="top">
            <td scope="row">Decimals</td>
            <td>
                <?php
                $selected = whmpress_get_option('decimals');
                $data = array(0,1,2,3);
                echo whmpress_draw_combo($data,$selected,"decimals");
                ?>
                
                <?php
                $selected = whmpress_get_option('decimals_tag');
                $data = array(
                    "" => "==No Tag==",
                    "b" => "Bold",
                    "i" => "Italic",
                    "u" => "Underline",
                    "sup" => "Superscript",
                    "sub" => "Subscript"
                );
                echo whmpress_draw_combo($data,$selected,"decimals_tag");
                ?>
            </td>
        </tr>
        <tr valign="top">
            <td scope="row">Show prefix</td>
            <td>
                <?php
                $selected = whmpress_get_option('prefix');
                $data = array(
                    "No" => "Do not show",
                    "Yes" => "Show prefix",
                    "b" => "Bold tag",
                    "i" => "Italic tag",
                    "u" => "Underline tag",
                    "sup" => "Superscript tag",
                    "sub" => "Subscript tag"
                );
                echo whmpress_draw_combo($data,$selected,"prefix");
                ?>
            </td>
        </tr>
        <tr valign="top">
            <td scope="row">Show suffix</td>
            <td>
                <?php
                $selected = whmpress_get_option('suffix');
                $data = array(
                    "No" => "Do not show",
                    "Yes" => "Show suffix",
                    "b" => "Bold tag",
                    "i" => "Italic tag",
                    "u" => "Underline tag",
                    "sup" => "Superscript tag",
                    "sub" => "Subscript tag"
                );
                echo whmpress_draw_combo($data,$selected,"suffix");
                ?>
            </td>
        </tr>
        <tr valign="top">
            <td scope="row">Show duration</td>
            <td>
                <?php
                $selected = whmpress_get_option('show_duration');
                $data = array(
                    "No" => "Do not show",
                    "Yes" => "Show duration",
                    "b" => "Bold tag",
                    "i" => "Italic tag",
                    "u" => "Underline tag",
                    "sup" => "Superscript tag",
                    "sub" => "Subscript tag"
                );
                echo whmpress_draw_combo($data,$selected,"show_duration");
                ?>
                
                <?php
                $selected = whmpress_get_option('duration_type');
                $data = array("loing"=>"Long Duration (Year)","short"=>"Short Duration (Yr)");
                echo whmpress_draw_combo($data,$selected,"duration_type");
                ?>
            </td>
        </tr>
    </table>
    <h3 class="whmp-sub-head">Order Combo Defaults <small>[whmpress_order_combo]</small></h3>
    <table class="form-table">
        <tr valign="top">
            <td style="width:30%;" scope="row">Show duration<br />
            <small>Press {Ctrl} button for multiple selection</small></td>
            <td>
                <?php
                $selected = whmpress_get_option('combo_billingcycles');
                $data = array("monthly"=>"Monthly",
                    "annually"=>"Annually",
                    "quarterly"=>"Quarterly",
                    "semiannually"=>"Semi Annually",
                    "biennially"=>"Biennially",
                    "triennially"=>"Triennially");
                echo whmpress_draw_combo_multiple($data,$selected,"combo_billingcycles");
                ?>
            </td>
        </tr>
        <tr valign="top">
            <td scope="row">Decimals</td>
            <td>
                <?php
                $selected = whmpress_get_option('combo_decimals');
                $data = array(0,1,2,3);
                echo whmpress_draw_combo($data,$selected,"combo_decimals");
                ?>
            </td>
        </tr>
        <tr valign="top">
            <td scope="row">Show button</td>
            <td>
                <?php
                $selected = whmpress_get_option('combo_show_button');
                $data = array("Yes","No");
                echo whmpress_draw_combo($data,$selected,"combo_show_button");
                ?>
            </td>
        </tr>
        <tr valign="top">
            <td scope="row">Rows</td>
            <td>
                <?php
                $selected = whmpress_get_option('combo_rows');
                $data = array("1"=>"1 Row, Combo and Button in same row","2"=>"2 Rows, Combo and Button id 2 rows");
                echo whmpress_draw_combo($data,$selected,"combo_rows");
                ?>
            </td>
        </tr>
        <tr valign="top">
            <td scope="row">Button text</td>
            <td>
                <?php
                $selected = whmpress_get_option('combo_button_text');
                ?>
                <input name="combo_button_text" value="<?php echo esc_attr( $selected ); ?>" required="required" />
            </td>
        </tr>
        <tr valign="top">
            <td scope="row">Show discount</td>
            <td>
                <?php
                $selected = whmpress_get_option('combo_show_discount');
                $data = array("Yes","No");
                echo whmpress_draw_combo($data,$selected,"combo_show_discount");
                
                $selected = whmpress_get_option('combo_discount_type');
                $data = array("yearly"=>"Yearly","monthly"=>"Monthly");
                echo whmpress_draw_combo($data,$selected,"combo_discount_type");                
                ?>
            </td>
        </tr>
        <tr valign="top">
            <td scope="row">Show prefix</td>
            <td>
                <?php
                $selected = whmpress_get_option('combo_prefix');
                $data = array("Yes","No");
                echo whmpress_draw_combo($data,$selected,"combo_prefix");
                ?>
            </td>
        </tr>
        <tr valign="top">
            <td scope="row">Show suffix</td>
            <td>
                <?php
                $selected = whmpress_get_option('combo_suffix');
                $data = array("Yes","No");
                echo whmpress_draw_combo($data,$selected,"combo_suffix");
                ?>
            </td>
        </tr>
        
        <tr>
            <td></td>
            <td colspan="3"><?php submit_button(); ?></td>
        </tr>
    </table>
</div>
</form>

<script>
/*jQuery(function(){
    var editor = CodeMirror.fromTextArea(document.getElementById("whmp_custom_css"), {
        lineNumbers: true,
        mode: 'css'
      });
      editor.setSize('900','500');
});*/
</script>
</div>

<script type="text/javascript">
jQuery(document).ready(function () {
    jQuery('ul.tabs').each(function(){
    // For each set of tabs, we want to keep track of
    // which tab is active and it's associated content
    var $active, $content, $links = jQuery(this).find('a');

    // If the location.hash matches one of the links, use that as the active tab.
    // If no match is found, use the first link as the initial active tab.
    $active = jQuery($links.filter('[href="'+location.hash+'"]')[0] || $links[0]);
    $active.addClass('active');

    $content = jQuery($active[0].hash);

    // Hide the remaining content
    $links.not($active).each(function () {
        jQuery(this.hash).hide();
    });

    // Bind the click event handler
    jQuery(this).on('click', 'a', function(e){
        // Make the old tab inactive.
        $active.removeClass('active');

        $content.hide();
    
        // Update the variables with the new link and content
        $active = jQuery(this);
        $content = jQuery(this.hash);
    
        // Make the tab active.
        $active.addClass('active');
        $content.show();
        
        // Prevent the anchor's default click action
        e.preventDefault();
    });
  });
});
</script>