<?php

// Just disply an array or object in human friendly manners
function whmp_show_array($ar, $show=false) {
    echo "<pre>";
    print_r ($ar, $show);
    echo "</pre>";
}
function whmp_get_domain_extension($domain) {
    $domain = str_replace("\n","",$domain);
    $domain = str_replace(chr(10),"",$domain);
    return trim(ltrim(strstr($domain, '.'),"."));
}

function whmp_get_pricing_table_name() {
    global $wpdb;
    return $wpdb->prefix . "whmpress_pricing";
}

function whmp_get_domainpricing_table_name() {
    global $wpdb;
    return $wpdb->prefix . "whmpress_domainpricing";
}

function whmp_get_domain_pricing_table_name() {
    global $wpdb;
    return $wpdb->prefix . "whmpress_domainpricing";
}

function whmp_get_products_table_name() {
    global $wpdb;
    return $wpdb->prefix . "whmpress_products";
}

function whmp_get_productgroups_table_name() {
    global $wpdb;
    return $wpdb->prefix . "whmpress_productgroups";
}

function whmp_get_product_group_table_name() {
    global $wpdb;
    return $wpdb->prefix . "whmpress_productgroups";
}

function whmp_get_currencies_table_name() {
    global $wpdb;
    return $wpdb->prefix . "whmpress_currencies";
}

function whmp_get_configuration_table_name() {
    global $wpdb;
    return $wpdb->prefix . "whmpress_configuration";
}

function whmp_get_group_table_name() {
    global $wpdb;
    return $wpdb->prefix . "whmpress_groups";
}

function whmp_get_group_detail_table_name() {
    global $wpdb;
    return $wpdb->prefix . "whmpress_groups_details";
}

function whmp_get_default_currency_code() {
    global $wpdb;
    $Q = "SELECT `code` FROM `".whmp_get_currencies_table_name()."` WHERE `default`='1'";
    return $wpdb->get_var($Q);
}

function whmp_get_default_currency_id() {
    global $wpdb;
    $Q = "SELECT `id` FROM `".whmp_get_currencies_table_name()."` WHERE `default`='1'";
    return $wpdb->get_var($Q);
}

function whmp_get_default_currency_prefix() {
    global $wpdb;
    $Q = "SELECT `prefix` FROM `".whmp_get_currencies_table_name()."` WHERE `default`='1'";
    return $wpdb->get_var($Q);
}

function whmp_get_default_currency_suffix() {
    global $wpdb;
    $Q = "SELECT `suffix` FROM `".whmp_get_currencies_table_name()."` WHERE `default`='1'";
    return $wpdb->get_var($Q);
}

function whmp_get_currency_code($id="") {
    if ($id=="") return whmp_get_default_currency_code();
    global $wpdb;
    $Q = "SELECT `code` FROM `".whmp_get_currencies_table_name()."` WHERE `id`='$id'";
    $currency_code = $wpdb->get_var($Q);
    if (empty($currency_code)) return whmp_get_default_currency_code();
    else return $currency_code;
}

function whmp_get_currency_prefix($id="") {
    if ($id=="") return whmp_get_default_currency_prefix();
    global $wpdb;
    $Q = "SELECT `prefix` FROM `".whmp_get_currencies_table_name()."` WHERE `id`='$id'";
    $currency_prefix = $wpdb->get_var($Q);
    //if (empty($currency_prefix)) return whmp_get_default_currency_prefix();
    //else return $currency_prefix;
    return $currency_prefix;
}

function whmp_get_currency_suffix($id="") {
    if ($id=="") return whmp_get_default_currency_suffix();
    global $wpdb;
    $Q = "SELECT `suffix` FROM `".whmp_get_currencies_table_name()."` WHERE `id`='$id'";
    $currency_suffix = $wpdb->get_var($Q);
    if ($currency_suffix=="") return whmp_get_default_currency_suffix();
    return $currency_suffix;
}

function whmp_get_installation_url() {
    global $wpdb;
    $whmcs_url = get_option("whmcs_url");
    if ($whmcs_url=="") {
        $Q = "SELECT `value` FROM `".whmp_get_configuration_table_name()."` WHERE `setting`='SystemURL'";
        return rtrim($wpdb->get_var($Q),"/");
    } else {
        return rtrim($whmcs_url,"/");
    }
}

function whmp_get_currency($curency_id="") {
    $curency_id = (int) $curency_id;
    if (empty($curency_id)) {
        if (isset($_SESSION["currency"])) return $_SESSION["currency"];
        return whmp_get_default_currency_id();
    } else {
        return $curency_id;
    }
}

function whmpress_draw_combo($dataArray, $selected="", $name="") {
    $OutputString = "<select name='$name'>\n";
    if (whmpress_is_assoc_array($dataArray)) {
        foreach($dataArray as $key=>$val) {
            $S = $key==$selected?"selected=selected":"";
            $OutputString .= "<option $S value=\"$key\">{$val}</option>\n";
        }
    } else {
        foreach($dataArray as $val) {
            $S = $val==$selected?"selected=selected":"";
            $OutputString .= "<option $S>{$val}</option>\n";
        }
    }
    $OutputString .= "</select>\n";
    return $OutputString;
}
function whmpress_draw_combo_multiple($dataArray, $selected=array(), $name) {
    $OutputString = "<select name='{$name}[]' multiple='multiple'>\n";
    if (!is_array($selected)) {
        $selected = explode(",",$selected);
    }
    $selected = array_map('trim',$selected);
    if (whmpress_is_assoc_array($dataArray)) {
        foreach($dataArray as $key=>$val) {
            $S = in_array($key,$selected)?"selected=selected":"";
            $OutputString .= "<option $S value=\"$key\">{$val}</option>\n";
        }
    } else {
        foreach($dataArray as $val) {
            $S = in_array($key,$selected)?"selected=selected":"";
            $OutputString .= "<option $S>{$val}</option>\n";
        }
    }
    $OutputString .= "</select>\n";
    return $OutputString;
}

function whmpress_is_assoc_array($arr) {
    return array_keys($arr) !== range(0, count($arr) - 1);
}

function whmpress_get_option($key_name, $default="") {
    $DefaultValues = array(
        "decimals" => "0",
        "billingcycle" => "annually",
        "hide_decimal" => "No",
        "decimals_tag" => "",
        "prefix" => "Yes",
        "suffix" => "No",
        "show_duration" => "Yes",
        "duration_type" => "long",
        "combo_billingcycles" => "",
        "combo_decimals" => "0",
        "combo_show_button" => "Yes",
        "combo_rows" => "1",
        "combo_button_text" => "Add to Cart",
        "combo_show_discount" => "Yes",
        "combo_prefix" => "Yes",
        "combo_suffix" => "No",
        "default_currency_symbol" => "prefix",
        "domain_not_available_message" => "Domain not available",
    );
    
    if ($default=="") {
        if (isset($DefaultValues[$key_name])) $default = $DefaultValues[$key_name];
    }
    
    $value = esc_attr(get_option($key_name, $default));
    
    if ($key_name=="whois_db" && trim($value)=="") {
        $value = wp_remote_get(WHMP_PLUGIN_URL."/includes/whoisdb");
        $value = @$value["body"];
    } 
    
    if (is_array($value))
        return array_map('trim',$value);
    else
        return trim($value);
}

function whmp_fetch_data($data=array(),$show_full_result=true) {
    // Connecting to WHMCS db for fetching data.
    if (!isset($data["db_server"])) $data["db_server"] = get_option("db_server");
    if (!isset($data["db_user"])) $data["db_user"] = get_option("db_user");
    if (!isset($data["db_pass"])) $data["db_pass"] = get_option("db_pass");
    if (!isset($data["db_name"])) $data["db_name"] = get_option("db_name");
    $conn = new mysqli($data["db_server"], $data["db_user"], $data["db_pass"], $data["db_name"]);
    
    if ($conn->connect_error) {
        if ($show_full_result)
            return "<h1>Unable to connect with WHMCS server: ".$conn->connect_error."</h1>";
        else
            return "Unable to connect with WHMCS server: \n".$conn->connect_error;
    }
    
    // Getting list of WHMPress decided tables
    global $Tables;
    
    global $wpdb;
    $Out = "";
    foreach($Tables as $table=>$newTable) {
        $newTableName = $wpdb->prefix."whmpress_".$newTable;
        
        $Q = "SHOW CREATE TABLE `".$table."`";
        $result = $conn->query($Q);
        if (!$result) {
            if ($show_full_result)
                return "<h1>Can't get data from table ".$table."</h1>";
            else
                return "Can't get data from table ".$table;
        }
        
        $row = $result->fetch_assoc();
        $newTableQ = $row["Create Table"];
        $result = $conn->query("SELECT * FROM `$table`");
        
        $newTableQ = str_replace("`$table`","`".$newTableName."`",$newTableQ);
        
        
        $Q = "DROP TABLE IF EXISTS `$newTableName`";
        $wpdb->query($Q);
        $wpdb->query($newTableQ);
        $wpdb->query("TRUNCATE `$newTableName`");
        $wpdb->query("ALTER TABLE `$newTableName` CONVERT TO CHARACTER SET utf8 COLLATE utf8_unicode_ci");
        $s=0; $f=0;
        while($row = $result->fetch_assoc()) {
            $response = $wpdb->insert($newTableName,$row);
            if ($response===false) $f++; else $s++;
        }
        $Out .= "<b>Caching $newTable:</b> <i>Successfully cached:</i> $s, <i>Failed:</i> $f<br />";
        update_option('sync_time', date("F, d Y - H:i"));
    }
    if ($show_full_result) return $Out;
    else {
        update_option('sync_time', date("F, d Y - H:i"));
        return "OK";
    }
}


/**
 * Check whether file editing is allowed for the .htaccess and robots.txt files
 *
 * @internal current_user_can() checks internally whether a user is on wp-ms and adjusts accordingly.
 *
 * @return bool
 */
function whmp_allow_system_file_edit() {
	$allowed = true;

	if ( current_user_can( 'edit_files' ) === false ) {
		$allowed = false;
	}

	/**
	 * Filter: 'whmp_allow_system_file_edit' - Allow developers to change whether the editing of
	 * .htaccess and robots.txt is allowed
	 *
	 * @api bool $allowed Whether file editing is allowed
	 */

	return apply_filters( 'whmp_allow_system_file_edit', $allowed );
}

/**
* Check if string is a valid utf8 or not
*
*/
if (!function_exists('is_utf8')) {
    function is_utf8($string) {
        return (mb_detect_encoding($string, 'UTF-8', true) == 'UTF-8');
    }
}

function whmp_get_service_types() {
    global $wpdb;
    $Q = "SELECT DISTINCT `type` FROM `".whmp_get_products_table_name()."` WHERE `type`<>''";
    $rows = $wpdb->get_results($Q,ARRAY_A);
    $realNames = array(
        "hostingaccount",
        "reselleraccount",
        "server",
        "other",
    );
    $changedNames = array(
        "Hosting Plans",
        "Reseller Plans",
        "VPS/Servers",
        "Other"
    );
    $Out = array();
    foreach($rows as $row) {
        $Out[ $row["type"] ] = str_replace($realNames,$changedNames,$row["type"]);
    }
    return $Out;
}

function whmp_get_type_groups($type) {
    $Q = "SELECT DISTINCT grps.`id`,grps.`name`,grps.`hidden` FROM `".whmp_get_product_group_table_name()."` grps, `".whmp_get_products_table_name()."` prds WHERE 
    prds.type='$type' AND prds.gid=grps.id ORDER BY grps.`order`";
    global $wpdb;
    return $wpdb->get_results($Q, ARRAY_A);
}

function whmp_get_products_by_group($group) {
    $Q = "SELECT * FROM `".whmp_get_products_table_name()."` WHERE 1";
    if (is_numeric($group)) {
        $group = (int) $group;
        $Q .= " AND `gid`='$group'";
    } else {
        $Q .= " AND `gid` IN (SELECT `id` gid FROM `".whmp_get_product_group_table_name()."` WHERE `name`='$group')";
    }
    global $wpdb;
    return $wpdb->get_results($Q,ARRAY_A);
}
function whmp_get_domain_extension_price($ext, $currency="") {
    global $wpdb;
    $ext = ".".ltrim($ext,".");
    if ($currency=="") $currency=whmp_get_currency_code();
    $Q = "SELECT d.id, d.extension 'tld', t.type, c.code, c.suffix, c.prefix, t.msetupfee
    FROM `".whmp_get_domain_pricing_table_name()."` AS d
    INNER JOIN `".whmp_get_pricing_table_name()."` AS t ON t.relid = d.id
    INNER JOIN `".whmp_get_currencies_table_name()."` AS c ON c.id = t.currency
    WHERE t.type
    IN (
    'domainregister'
    ) AND d.extension IN ('{$ext}')
    AND c.code='$currency' 
    ORDER BY d.id ASC 
    LIMIT 0 , 30";
    
    return $wpdb->get_row($Q,ARRAY_A);
}

function whmp_is_product_in_group($product_id, $group_id) {
    $Q = "SELECT COUNT(*) FROM `".whmp_get_group_detail_table_name()."` WHERE `product_id`='$product_id' AND `group_id`='$group_id'";
    global $wpdb;
    return $wpdb->get_var($Q)>0;
}

function whmp_delete_group($group_id) {
    global $wpdb;
    $Q = "DELETE FROM `".whmp_get_group_table_name()."` WHERE `id`='$group_id'";
    $wpdb->query($Q);
    $Q = "DELETE FROM `".whmp_get_group_detail_table_name()."` WHERE `group_id`='$group_id'";
    $wpdb->query($Q);
}

function whmp_get_group_full($id) {
    global $wpdb;
    $result = array();
    $Q = "SELECT * FROM `".whmp_get_group_table_name()."` WHERE `id`=".$id;
    $result = $wpdb->get_row($Q,ARRAY_A);
    
    $Q = "SELECT * FROM `".whmp_get_group_detail_table_name()."` WHERE `group_id`=".$id;
    $rows = $wpdb->get_results($Q,ARRAY_A);
    
    foreach($rows as &$row) {
        $Q = "SELECT `name`,`description` FROM `".whmp_get_products_table_name()."` WHERE `id`=".$row["product_id"];
        $R = $wpdb->get_row($Q,ARRAY_A);
        $row = array_merge($row,$R);
    }
    
    $result["plans"] = $rows;
    
    return $result;
}

/*
// Replace blank prefix with suffix
$Q = "UPDATE `".whmp_get_currencies_table_name()."` SET `prefix`=`suffix` WHERE `prefix`='' AND `suffix`<>''";
$wpdb->query($Q);
// Replace blank suffix with prefix
$Q = "UPDATE `".whmp_get_currencies_table_name()."` SET `suffix`=`prefix` WHERE `suffix`='' AND `prefix`<>''";
$wpdb->query($Q);
*/