<?php
if (!function_exists('add_action')) {
    header('Status: 403 Forbidden');
    header('HTTP/1.1 403 Forbidden');
    exit();
}

/**
 * WHMPress uses session variables when currency is selected
 * These hooks control session early.
 * 
 * Thanks to peter at http://silvermapleweb.com/using-the-php-session-in-wordpress/
 */
add_action('init', 'whmpress_session_start', 1);
add_action('wp_logout', 'whmpress_session_end');
add_action('wp_login', 'whmpress_session_end');
function whmpress_session_end() {
    session_destroy ();
}
function whmpress_session_start() {
    if(!session_id()) {
        session_start();
    }
}

# Getting data version from plugin file
if ( ! function_exists( 'get_plugins' ) ) {
	require_once ABSPATH . 'wp-admin/includes/plugin.php';
}
$plugin_data = get_plugin_data( dirname(__FILE__)."/whmpress.php" );

defined('WHMP_VERSION')
    || define('WHMP_VERSION', plugin_get_version());

defined('WHMP_PLUGIN_NAME')
    || define('WHMP_PLUGIN_NAME', basename(dirname(__FILE__)));

defined('WHMP_PLUGIN_DIR')
    || define('WHMP_PLUGIN_DIR', untrailingslashit(plugin_dir_path(__FILE__)));

defined('WHMP_PLUGIN_URL')
    || define('WHMP_PLUGIN_URL', untrailingslashit(plugins_url(WHMP_PLUGIN_NAME)));

defined('WHMP_ADMIN_DIR')
    || define('WHMP_ADMIN_DIR', WHMP_PLUGIN_DIR . '/admin');

defined('WHMP_ADMIN_URL')
    || define('WHMP_ADMIN_URL', WHMP_PLUGIN_URL . '/admin');
    


/* Setting WHMpress tables */
global $wpdb;
$Q = "
CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}whmpress_groups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `description` text NOT NULL,
  `important` int(11) NOT NULL,
  `rows` tinyint(4) NOT NULL,
  `currency` int(11) NOT NULL,
  `color` varchar(10) NOT NULL,
  `ribbon_text` varchar(50) NOT NULL,
  `billingcycle` varchar(10) NOT NULL,
  `html_class` varchar(10) NOT NULL,
  `html_id` varchar(10) NOT NULL,
  `decimals` tinyint(4) NOT NULL,
  `decimals_tag` varchar(10) NOT NULL,
  `hide_decimal` varchar(5) NOT NULL,
  `prefix` varchar(3) NOT NULL,
  `suffix` varchar(3) NOT NULL,
  `show_duration` varchar(3) NOT NULL,
  `show_duration_as` varchar(10) NOT NULL,
  `convert_monthly` varchar(3) NOT NULL,
  `alternate_rows` BOOLEAN NOT NULL DEFAULT FALSE,
  `button_text` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=latin1
";
$wpdb->query($Q);

$Q = "
CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}whmpress_groups_details` (
  `group_id` int(11) NOT NULL,
  `product_id` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1
";
$wpdb->query($Q);

$Q = "SELECT `button_text` FROM `{$wpdb->prefix}whmpress_groups`";
$col = $wpdb->get_row($Q);
if (!is_object($col)) {
    $Q = "ALTER TABLE `{$wpdb->prefix}whmpress_groups` ADD `button_text` varchar(50) NOT NULL";
    $wpdb->query($Q);
}