<?php
/*
Plugin Name: WHMpress
Plugin URI: http://www.whmpress.com
Description: WHMpress makes it easy for you to sell webhosting using WordPress & WHMCS. It offers you several options including prices, order links, order button, order drop downs, domain registration and domain search forms to integrate WHMCS services (plans, packages, resellers packages, VPS & dedicated servers) into your wordpress installation.
Version: 1.2.0
Author: 20Script
Author URI: http://www.20script.ir
*/

// Prevent direct file access
if (!function_exists('add_action')) {
    header('Status: 403 Forbidden');
    header('HTTP/1.1 403 Forbidden');
    exit();
}

if (!function_exists('plugin_get_version')) {
    function plugin_get_version() {
        if ( ! function_exists( 'get_plugins' ) )
            require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
        $plugin_folder = get_plugins( '/' . plugin_basename( dirname( __FILE__ ) ) );
        $plugin_file = basename( ( __FILE__ ) );
        return $plugin_folder[$plugin_file]['Version'];
    }
}

include_once (dirname(__FILE__).'/whmpress.init.php');
include_once (WHMP_PLUGIN_DIR.'/includes/functions.php');


/*
// Not working yet.
// Adding link into plugin page
// Add settings link on plugin page
add_filter( 'plugin_action_links_' . plugin_basename( WHMP_PLUGIN_DIR ), 'whmpress_settings_link');
function whmpress_settings_link( $links ) {
    #die("Died.....");
	#$links[] = '<a href="' . admin_url( 'themes.php?page=simple-custom-css.php' ) .'">View WHMpress</a>';
	//array_unshift( $links, $settings_page );
    //return array_merge( $links, $settings_page );
	return $links;
}
*/

function register_WHMP_settings() {    
    # Settings page
    register_setting( 'whmp_settings', 'whmcs_url');
    register_setting( 'whmp_settings', 'whmp_custom_css' );
    register_setting( 'whmp_settings', 'tld_order' );
    register_setting( 'whmp_settings', 'domain_available_message' );
    register_setting( 'whmp_settings', 'domain_not_available_message' );
    register_setting( 'whmp_settings', 'domain_recommended_list' );
    register_setting( 'whmp_settings', 'ongoing_domain_not_available_message' );
    register_setting( 'whmp_settings', 'no_of_domains_to_show' );
    register_setting( 'whmp_settings', 'whois_db' );
    register_setting( 'whmp_settings', 'billingcycle' );
    register_setting( 'whmp_settings', 'decimals' );
    register_setting( 'whmp_settings', 'hide_decimal' );
    register_setting( 'whmp_settings', 'decimals_tag' );
    register_setting( 'whmp_settings', 'prefix' );
    register_setting( 'whmp_settings', 'suffix' );
    register_setting( 'whmp_settings', 'show_duration' );
    register_setting( 'whmp_settings', 'duration_type' );
    register_setting( 'whmp_settings', 'combo_billingcycles' );
    register_setting( 'whmp_settings', 'combo_decimals' );
    register_setting( 'whmp_settings', 'combo_show_button' );
    register_setting( 'whmp_settings', 'combo_rows' );
    register_setting( 'whmp_settings', 'combo_button_text' );
    register_setting( 'whmp_settings', 'combo_show_discount' );
    register_setting( 'whmp_settings', 'combo_discount_type' );
    register_setting( 'whmp_settings', 'combo_prefix' );
    register_setting( 'whmp_settings', 'combo_suffix' );
    register_setting( 'whmp_settings', 'decimal_replacement' );
    register_setting( 'whmp_settings', 'default_currency_symbol' );
    register_setting( 'whmp_settings', 'include_fontawesome' );
    
    # WHMCS sync page
    register_setting( 'whmp_whmcs_settings', 'db_server' );
    register_setting( 'whmp_whmcs_settings', 'db_name' );
    register_setting( 'whmp_whmcs_settings', 'db_user' );
    register_setting( 'whmp_whmcs_settings', 'db_pass' );
    register_setting( 'whmp_whmcs_settings', 'sync_run');
    register_setting( 'whmp_whmcs_settings', 'sync_time' );
}
add_action( 'admin_init', 'register_WHMP_settings' );

// Initialize all shortcodes
include_once (WHMP_PLUGIN_DIR."/includes/shortcodes.php");

// Adding functionality of addons.
if (is_dir(WHMP_PLUGIN_DIR."/addons")) {
    $addons_files = @glob(WHMP_PLUGIN_DIR."/addons/*.php");
    if (is_array($addons_files)) foreach($addons_files as $addon_file) {
        include_once ($addon_file);
    }
}

if (is_admin()) {
    require_once WHMP_ADMIN_DIR . '/admin.php';
    add_action('wp_ajax_whmpress_action', 'whmp_frontend_ajax_action');
    add_action('wp_ajax_nopriv_whmpress_action', 'whmp_frontend_ajax_action');
}


function whmp_frontend_ajax_action() {
    require_once (WHMP_PLUGIN_DIR . "/includes/ajax.php");
}

function whmp_theme_name_scripts() {
  // Load a javascript file
  wp_enqueue_script( 'script-name', WHMP_PLUGIN_URL . '/js/whmpress.js', array('jquery'), '1.0.0', true );
  wp_localize_script( 'script-name', 'MyAjax', array(
    // URL to wp-admin/admin-ajax.php to process the request
    //'ajaxurl' => admin_url( 'admin-ajax.php' ),
    'ajaxurl' => WHMP_PLUGIN_URL.'/includes/ajax.php',
 
    // generate a nonce with a unique ID "myajax-post-comment-nonce"
    // so that you can check it later when an AJAX request is sent
    'security' => wp_create_nonce( '45Gf&*wS4#' )
  ));
  wp_localize_script( 'script-name', 'page', '1');
  wp_enqueue_script( 'QuickSearch', WHMP_PLUGIN_URL . '/js/jquery.quicksearch.js', array(), false, true );
  //wp_enqueue_style('whmpressstyle', WHMP_PLUGIN_URL . '/whmpress.css' );
  wp_enqueue_style('pricetables', WHMP_PLUGIN_URL . '/styles/pricetables/pricing-tables.min.css' );
  
  // If WHMPress settings -> Styles -> include FontAwesome selected Yes
  if (get_option('include_fontawesome')=="1") {
        wp_enqueue_style('font-awesome-script', "//maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css" );
  }
}
add_action( 'wp_enqueue_scripts', 'whmp_theme_name_scripts' );


/**
 * Implementing Custom CSS
 */
function whmp_get_custom_css() {
    if (get_option("whmp_custom_css")=="") {
        $custom_css_file = WHMP_PLUGIN_DIR . "/styles/default.css";
    } else {
        $custom_css_file = WHMP_PLUGIN_DIR . "/styles/" . get_option("whmp_custom_css");
        if (!file_exists($custom_css_file)) $custom_css_file = WHMP_PLUGIN_DIR . "/styles/default.css";
    }
    
    //$custom_css_file = WHMP_PLUGIN_DIR . "/styles/themes/" . get_option("whmp_custom_css");
    $custom_css = file_get_contents($custom_css_file);
    
    if ( @$custom_css ) {
        $css = '<!-- WHMpress Styles -->' . "\n";
    	$css .= '<style>' . "\n";
    	$css .= $custom_css . "\n";
    	$css .= '</style>' . "\n";
    	$css .= '<!-- Generated by WHMpress -->' . "\n";
    
    	echo $css;
    }
}
add_action( 'wp_head', 'whmp_get_custom_css', 20 );

function whmpress_replace_content($content) {
    $content = str_replace('-**-', '&#91;',$content);
    $content = str_replace('_**_', '&#93;',$content);
    return $content;
}
add_filter('the_content','whmpress_replace_content');

/*
* Tables used from WHMCS DB
*/
$Tables = array(
    "tblpricing"=>"pricing",
    "tblproducts"=>"products",
    "tblproductgroups"=>"productgroups",
    "tblcurrencies"=>"currencies",
    "tbldomainpricing"=>"domainpricing",
    "tblconfiguration"=>"configuration"
);